<?xml version="1.0" encoding="Shift_JIS"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="text" encoding="Shift_JIS"/>

	<xsl:template match="/">
		<xsl:apply-templates select="/ResultsSession/CodingStandards/StdViols"/>
	</xsl:template>

	<!-- CSV̍i -->
	<xsl:template match="/ResultsSession/CodingStandards/StdViols">
		<xsl:text>쐬,t@C,s,[ID,dvxx,bZ[W,(C)/os(P),YR[h&#xd;&#xa;</xsl:text>
		<xsl:apply-templates select="StdViol"/>
		<xsl:apply-templates select="FlowViol"/>
		<xsl:text>&#xd;&#xa;</xsl:text>
		<xsl:text>(C)/os(P),C:ᔽ̌ƂȂs(Cause),P:ᔽoꂽs(Point),!:dvȏt[</xsl:text>
	</xsl:template>

	<!-- R[fBO[ -->
	<xsl:template match="/ResultsSession/CodingStandards/StdViols/StdViol">
		<xsl:call-template name="StaticAnalysis"/>
	</xsl:template>

	<!-- t[ -->
	<xsl:template match="/ResultsSession/CodingStandards/StdViols/FlowViol">
		<xsl:call-template name="StaticAnalysis"/>
	</xsl:template>

	<!-- 1̐ÓI͌ʂo -->
	<xsl:template name="StaticAnalysis">
		<xsl:value-of select="@auth"/>
		<xsl:text>,</xsl:text>
		<xsl:call-template name="getFileName">
			<xsl:with-param name="loc" select="@locFile"/>
		</xsl:call-template>
		<!-- <xsl:value-of select="@locFile"/> -->
		<xsl:text>,</xsl:text>
		<xsl:value-of select="@ln"/>
		<xsl:text>,</xsl:text>
		<xsl:value-of select="@rule"/>
		<xsl:text>,</xsl:text>
		<xsl:value-of select="@sev"/>
		<xsl:text>,&quot;</xsl:text>
		<xsl:call-template name="quote">
			<xsl:with-param name="text" select="@msg"/>
		</xsl:call-template>
		<xsl:text>&quot;&#xd;&#xa;</xsl:text>
		<xsl:apply-templates select="ElDescList"/>
	</xsl:template>

	<!-- t[̃Xgo -->
	<xsl:template match="ElDescList">
		<xsl:param name="depth">0</xsl:param>
		<xsl:apply-templates select="ElDesc">
			<xsl:with-param name="depth" select="$depth + 1"/>
		</xsl:apply-templates>
	</xsl:template>

	<!-- t[1so -->
	<xsl:template match="ElDesc">
		<xsl:param name="depth"/>
		<xsl:text>V,</xsl:text>
		<xsl:call-template name="getFileName">
			<xsl:with-param name="loc" select="@srcRngFile"/>
		</xsl:call-template>
		<xsl:text>,</xsl:text>
		<xsl:value-of select="@ln"/>
		<xsl:text>,</xsl:text><xsl:text>,</xsl:text><xsl:text>,</xsl:text><xsl:text>,</xsl:text>
		<xsl:value-of select="@ElType"/>
		<xsl:text>,</xsl:text>
		<xsl:call-template name="indent">
			<xsl:with-param name="depth" select="$depth"/>
		</xsl:call-template>
		<xsl:text>&quot;</xsl:text>
		<xsl:call-template name="quote">
			<xsl:with-param name="text" select="@desc"/>
		</xsl:call-template>
		<xsl:text>&quot;&#xd;&#xa;</xsl:text>
		<xsl:apply-templates select="ElDescList"> <!-- ֐Ăяo -->
			<xsl:with-param name="depth" select="$depth"/>
		</xsl:apply-templates>
	</xsl:template>

	<!-- t@Co -->
	<xsl:template name="getFileName">
		<xsl:param name="loc"/>
		<xsl:choose>
			<xsl:when test="/ResultsSession/Locations/Loc[@loc=$loc]">
				<xsl:value-of select="/ResultsSession/Locations/Loc[@loc=$loc]/@fsPath"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$loc"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- CSV֏o͂邽߁ANI[g -->
	<xsl:template name="quote">
		<xsl:param name="text"/>
		<xsl:choose>
			<xsl:when test="contains($text, '&quot;')">
				<xsl:value-of select="substring-before($text, '&quot;')"/>
				<xsl:text>&quot;&quot;</xsl:text>
				<xsl:call-template name="quote">
					<xsl:with-param name="text" select="substring-after($text, '&quot;')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- ֐ĂяõCfg -->
	<xsl:template name="indent">
		<xsl:param name="depth"/>
		<xsl:if test="$depth &gt; 1">
			<xsl:text>,</xsl:text>
			<xsl:call-template name="indent">
				<xsl:with-param name="depth" select="$depth - 1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
